// > *** MoReFEM Doxygen information and copyright notice *** //
/*!
 * This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
 * It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
 *
 * MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
 * You may contact its developers by writing at morefem-maint@inria.fr.
 *
 * \file
 *
 * \ingroup UtilitiesGroup
 * \addtogroup UtilitiesGroup
 * @{
 */
// *** MoReFEM Doxygen information and copyright notice *** < //


// > *** MoReFEM header guards *** //
#ifndef MOREFEM_UTILITIES_INPUTDATA_INTERNAL_TUPLEITERATION_PRINT_DOT_HPP_
#define MOREFEM_UTILITIES_INPUTDATA_INTERNAL_TUPLEITERATION_PRINT_DOT_HPP_
// *** MoReFEM header guards *** < //

// IWYU pragma: no_include <iosfwd>

#include <deque>
#include <fstream>
#include <string> // IWYU pragma: keep
#include <unordered_map>
#include <utility>
#include <vector>

#include "Utilities/InputData/Internal/Write/Enum.hpp"


namespace MoReFEM::Internal::InputDataNS
{


    /*!
     * \brief Write a dumb string to indicate that the field in the newly created input file needs to
     * be filled properly.
     *
     * \return The string chosen as placeholder.
     */
    const std::string& GetIndentPlaceholder();


    /*!
     * \brief Print in the input data file being created the content of a section.
     *
     * \param[in] item_block_per_identifier First item is the full key is the input data file (e.g.
     * "domain4.name"); second is the while text to be written in the generated input data file.
     * This is generated by TupleIteration<>::PrepareDefaultEntries().
     * \copydoc doxygen_hide_stream_inout
     *
     * \param[in] indexed_section_description_list For each \a IndexedSection (which full name is the key
     * of the container)
     * \copydoc doxygen_hide_indexed_section_description_list_extended_arg_description
     *
     * \copydoc doxygen_hide_input_data_rewrite_lua_verbosity
     */
    void PrintInFile(const std::vector<std::pair<std::string, std::string>>& item_block_per_identifier,
                     std::ostream& stream,
                     const std::unordered_map<std::string, std::deque<std::string>>& indexed_section_description_list,
                     verbosity verbosity_level = verbosity::verbose);


} // namespace MoReFEM::Internal::InputDataNS


// > *** MoReFEM Doxygen end of group *** //
///@} // \addtogroup UtilitiesGroup
// *** MoReFEM Doxygen end of group *** < //


// > *** MoReFEM end header guards *** //
#endif // MOREFEM_UTILITIES_INPUTDATA_INTERNAL_TUPLEITERATION_PRINT_DOT_HPP_
// *** MoReFEM end header guards *** < //
